View Javadoc

    1   /*
    2    * $Id: DefaultGroovyStaticMethods.java,v 1.3 2004/05/18 06:15:45 spullara Exp $
    3    *
    4    * Copyright 2003 (C) James Strachan and Bob Mcwhirter. All Rights Reserved.
    5    *
    6    * Redistribution and use of this software and associated documentation
    7    * ("Software"), with or without modification, are permitted provided that the
    8    * following conditions are met:
    9    *  1. Redistributions of source code must retain copyright statements and
    10   * notices. Redistributions must also contain a copy of this document.
    11   *  2. Redistributions in binary form must reproduce the above copyright
    12   * notice, this list of conditions and the following disclaimer in the
    13   * documentation and/or other materials provided with the distribution.
    14   *  3. The name "groovy" must not be used to endorse or promote products
    15   * derived from this Software without prior written permission of The Codehaus.
    16   * For written permission, please contact info@codehaus.org.
    17   *  4. Products derived from this Software may not be called "groovy" nor may
    18   * "groovy" appear in their names without prior written permission of The
    19   * Codehaus. "groovy" is a registered trademark of The Codehaus.
    20   *  5. Due credit should be given to The Codehaus - http://groovy.codehaus.org/
    21   *
    22   * THIS SOFTWARE IS PROVIDED BY THE CODEHAUS AND CONTRIBUTORS ``AS IS'' AND ANY
    23   * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
    24   * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    25   * DISCLAIMED. IN NO EVENT SHALL THE CODEHAUS OR ITS CONTRIBUTORS BE LIABLE FOR
    26   * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    27   * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
    28   * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
    29   * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    30   * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    31   * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
    32   * DAMAGE.
    33   *
    34   */
    35  package org.codehaus.groovy.runtime;
    36
    37  import groovy.lang.Closure;
    38
    39  import java.util.regex.Matcher;
    40
    41  /***
    42   * This class defines all the new static groovy methods which appear on normal JDK
    43   * classes inside the Groovy environment. Static methods are used with the
    44   * first parameter as the destination class.
    45   *
    46   * @author Guillaume Laforge
    47   * @version $Revision: 1.3 $
    48   */
    49  public class DefaultGroovyStaticMethods {
    50
    51      /***
    52       * Start a Thread with the given closure as a Runnable instance.
    53       *
    54       * @param closure the Runnable closure
    55       * @return the started thread
    56       */
    57      public static Thread start(Thread self, Closure closure) {
    58          Thread thread = new Thread(closure);
    59          thread.start();
    60          return thread;
    61      }
    62
    63      /***
    64       * Start a daemon Thread with the given closure as a Runnable instance.
    65       *
    66       * @param closure the Runnable closure
    67       * @return the started thread
    68       */
    69      public static Thread startDaemon(Thread self, Closure closure) {
    70          Thread thread = new Thread(closure);
    71          thread.setDaemon(true);
    72          thread.start();
    73          return thread;
    74      }
    75
    76      /***
    77       * Get the last hidden matcher that system used to do a match.
    78       *
    79       * @param matcher
    80       * @return
    81       */
    82      public static Matcher getLastMatcher(Matcher matcher) {
    83          return RegexSupport.getLastMatcher();
    84      }
    85  }